当前位置: 代码迷 >> 综合 >> 杭电Oj3555 Bomb【数位DP】
  详细解决方案

杭电Oj3555 Bomb【数位DP】

热度:95   发布时间:2023-12-29 17:25:14.0

题目链接:HDU-2089

题目描述

Bomb
Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 131072/65536 K (Java/Others)
Total Submission(s): 24909 Accepted Submission(s): 9408

Problem Description
The counter-terrorists found a time bomb in the dust. But this time the terrorists improve on the time bomb. The number sequence of the time bomb counts from 1 to N. If the current number sequence includes the sub-sequence “49”, the power of the blast would add one point.
Now the counter-terrorist knows the number N. They want to know the final points of the power. Can you help them?

Input
The first line of input consists of an integer T (1 <= T <= 10000), indicating the number of test cases. For each test case, there will be an integer N (1 <= N <= 2^63-1) as the description.

The input terminates by end of file marker.

Output
For each test case, output an integer indicating the final points of the power.

Sample Input
3
1
50
500

Sample Output
0
1
15

思路

数位DP解决的是类似于 给你一个区间L到R,然后让你求出满足某个条件P的数字有多少个;
然后在我理解中,数位DP就是记忆化搜索+dfs, 感觉名字是DP,其实的实质是dfs+记忆化搜索;

举个栗子:
我们要找 0 - 9999 之间没有62的数字有多少个;用朴素的算法可能就是暴力遍历每一个元素, 然后判断该数字是否满足这个条件P, 但是题目的数据范围一般都是 1 <= l <= r <= 10 ^ 18,暴力肯定会T掉,所以我们需要更优的做法;
然后数位DP要做的就是优化这个数shu(二声)数(四声)的过程;
上图说明:

我们可以将0 - 9999抽像为选择每一位数字的过程。然后我们可以优化这个数数的过程;
试想, (以之前栗子为栗子),当前两位已经选定为 00,然后当第三位选择0 , 1, 2, 3, 4, 5, 7, 8 ,9的种类数是一样多的,我们只需要统计一次即可,其他的都一样无需重复统计;
然后再往上一层。 当第一位选定为 0 时, 我们统计出此时满足条件P的方案数。那么 当首位为 1, 2, 3, 4, 5, 7, 8,9, 的方案数都和首位为0时的方案数一致,我们无需重复统计就可以得出答案;
OK, 这个就是数位DP, 然后需要注意一些细节,就是满足P的方案统计和方案上限的统计;(这种都需要重新统计一下);具体的过程我感觉我码字说不清楚,这里推荐一个教的很好的视频,大家可以学习一下;

数位DP学习视频

此题是裸的数位DP。稍微学习一下就可以过了;

AC代码:

#include <bits/stdc++.h>
using namespace std;#define long long long
#define INF 0x3f3f3f3f
#define MAX_N 100010long dp[50][2];
long digit[50];long dfs(long k, bool if4, bool limit)
{
    if(k == 0)return 1;if(!limit && dp[k][if4])return dp[k][if4];long cnt = 0, up_bound = (limit ? digit[k] : 9);for(int i = 0; i <= up_bound; i++){
    if(if4 && i == 9)continue;cnt += dfs(k - 1, i == 4, limit && i == digit[k]);}if(!limit)dp[k][if4] = cnt;return cnt;
}long solve(long num)
{
    long k = 0;while(num){
    digit[++k] = num % 10;num /= 10;}return dfs(k, false, true);
}int main()
{
    ios::sync_with_stdio(false);cin.tie(0);cout.tie(0);int t;cin >> t;while(t--){
    long n;cin >> n;cout << n + 1 - solve(n) << endl;}return 0;
}